/*
 * digipot.c
 *
 * Created: 31.10.2011 15:07:53
 *  Author: gobe
 */ 

#include "pga.h"
#include <util/delay.h>

void PGAInit(void)
{
	_delay_ms(100);

	PGA_DDR = (1<<PGA_SDI)|(1<<PGA_SCLK)|(1<<PGA_CS)|(1<<PGA_ZCEN);		// PGA Pins -> Output

	#ifdef PGA_DELAY
		PGA_DELAY
	#endif

	PGA_PORT &= ~(1<<PGA_SCLK);					// clock LOW

	#ifdef PGA_DELAY
		PGA_DELAY
	#endif

	PGA_PORT |= (1<<PGA_ZCEN);					// enable ZC
}

void PGAShiftOut(unsigned char dataPin, unsigned char clockPin, unsigned char val)
{
	unsigned char i;

    for (i = 0; i < 8; i++)
	{
        PGA_PORT &= ~(1<<clockPin);			// clock LOW
        if (!!(val & (1 << (7 - i)))) 		// MSBFIRST
		{
			PGA_PORT |= (1<<dataPin);
		}
		else
		{
			PGA_PORT &= ~(1<<dataPin);
		}
        PGA_PORT |=  (1<<clockPin);			// clock HIGH
	}
}

void PGAWrite(unsigned char leftVal, unsigned char rightVal)
{
	PGA_PORT &= ~(1<<PGA_CS);					// CS LOW

	#ifdef PGA_DELAY
		PGA_DELAY
	#endif

	PGAShiftOut(PGA_SDI, PGA_SCLK, rightVal);	// right channel

	#ifdef PGA_DELAY
		PGA_DELAY
	#endif

	PGAShiftOut(PGA_SDI, PGA_SCLK, leftVal);	// left channel

	#ifdef PGA_DELAY
		PGA_DELAY
	#endif

	PGA_PORT |= (1<<PGA_CS);					// CS HIGH
}

void PGASetZC(unsigned char enable)
{
	if (enable)
		PGA_PORT |= (1<<PGA_ZCEN);
	else
		PGA_PORT &= ~(1<<PGA_ZCEN);

	#ifdef PGA_DELAY
		PGA_DELAY
	#endif
}
